
ZFA.SKAT.mmulthread <- function(data,y,boundResult,test,obj,bin,fast.path,filter.pval,adjacent,result.final){
  myidx <- parallel::splitIndices(nrow(boundResult),myinfo$nwrkrs)[[myinfo$id]]
  for(i in myidx){
    low_idx <- ifelse(adjacent,1,boundResult[i,1])
    up_idx <- ifelse(adjacent,ncol(data),boundResult[i,2])
    # zoom
    if(fast.path){
      lower<-boundResult[i,1]
      upper<-boundResult[i,2]
      mid<-boundResult[i,2]-boundResult[i,1]+1
      if (test=="SKAT") {
        pvalue<-SKAT::SKATBinary(data[,c(lower:upper)],obj)$p.value
      } else if (test=="SKATO") {
        pvalue<-SKAT::SKATBinary(data[,c(lower:upper)],obj,method="SKATO")$p.value
      } else if (test=="burden") {
        pvalue<-SKAT::SKATBinary(data[,c(lower:upper)],obj,method="Burden")$p.value
      }
      pvalue.all<-pvalue
      upper.all<-upper
      lower.all<-lower
      while (mid>3){
        mid<-floor(mid/2)
        if (test=="SKAT") {
          pvalue.left<-(SKAT::SKATBinary(data[,c(lower:(lower+mid-1))],obj)$p.value)
          pvalue.right<-(SKAT::SKATBinary(data[,c((upper-mid+1):upper)],obj)$p.value)
        } else if (test=="SKATO") {
          pvalue.left<-(SKAT::SKATBinary(data[,c(lower:(lower+mid-1))],obj,method="SKATO")$p.value)
          pvalue.right<-(SKAT::SKATBinary(data[,c((upper-mid+1):upper)],obj,method="SKATO")$p.value)
        } else if (test=="burden") {
          pvalue.left<-(SKAT::SKATBinary(data[,c(lower:(lower+mid-1))],obj,method="Burden")$p.value)
          pvalue.right<-(SKAT::SKATBinary(data[,c((upper-mid+1):upper)],obj,method="Burden")$p.value)
        }
        pvalue<-min(pvalue.left,pvalue.right)
        if (pvalue==pvalue.left){
          upper<-upper-mid
        } else if (pvalue==pvalue.right){
          lower<-lower+mid
        }
        pvalue<-ifelse(pvalue>1,1,pvalue)
        pvalue.all<-c(pvalue.all,pvalue)
        upper.all<-c(upper.all,upper)
        lower.all<-c(lower.all,lower)
      }
      pvalue.final<-min(pvalue.all)
      upper.final<-upper.all[which(pvalue.all==pvalue.final)[1]]
      lower.final<-lower.all[which(pvalue.all==pvalue.final)[1]]
      pvalue.final<-pvalue.final
      pvalue.final<-ifelse(pvalue.final>1,1,pvalue.final)
      result<-cbind(lower.final,upper.final,pvalue.final)
      colnames(result)<-c("lower","upper","p.value")
    }else{
      P<-ncol(data[,boundResult[i,1]:boundResult[i,2]])
      R<-floor(log2(P))
      r<-c(1:R)
      nr<-c(2^(r-1))
      d<-P/nr 
      result.all<-NULL
      for (j in 1:R) {
        d1<-d[j]
        nr1<-nr[j]
        c<-c(1:nr1)
        lower.all<-(d1*(c-1)+1)+boundResult[i,1]-1
        upper.all<-(d1*c)+boundResult[i,1]-1
        pvalue.all<-NULL
        for (k in 1:nr1){
          if (test=="SKAT") {
            pvalue<-SKAT::SKATBinary(data[,c(lower.all[k]:upper.all[k])],obj)$p.value*nr1
          } else if (test=="SKATO") {
            pvalue<-SKAT::SKATBinary(data[,c(lower.all[k]:upper.all[k])],obj,method="SKATO")$p.value*nr1
          } else if (test=="burden") {
            pvalue<-SKAT::SKATBinary(data[,c(lower.all[k]:upper.all[k])],obj,method="Burden")$p.value*nr1
          }
          pvalue<-ifelse(pvalue>1,1,pvalue)
          pvalue.all<-c(pvalue.all,pvalue)
        }
        result<-cbind(lower.all,upper.all,pvalue.all)
        result.all<-rbind(result.all,result)
      }
      pvalue.final<-result.all[,3]
      pvalue.final<-ifelse(pvalue.final>1,1,pvalue.final)
      result.all<-cbind(result.all[,1:2],pvalue.final)
      colnames(result.all)<-c("lower","upper","p.value")
      order.pvalue<-order(result.all[,"p.value"],decreasing=F)
      result <- t(result.all[order.pvalue[1],])
    }
    # focus
    filter.pval<-ifelse(is.null(filter.pval),1,filter.pval)
    steps <- 0
    if (result[,"p.value"]<=filter.pval){
      d<-result[,"upper"]-result[,"lower"]+1
      if (d==2) {
        inward<-0
        outward<-2*d
      } else {
        inward<-floor(d/4)
        outward<-floor(d/2)
      }
      pvalue.left<-NULL
      lb.all<-NULL
      for (j in (-outward):(inward)) {
        lb.new<-result[,"lower"]+j
        if (lb.new>=low_idx) {
          lb.all<-rbind(lb.all,lb.new)
          if (test=="SKAT") {
            pvalue.left<-rbind(pvalue.left,SKAT::SKATBinary(data[,c(lb.new:result[,"upper"])],obj)$p.value)
          } else if (test=="SKATO") {
            pvalue.left<-rbind(pvalue.left,SKAT::SKATBinary(data[,c(lb.new:result[,"upper"])],obj,method="SKATO")$p.value)
          } else if (test=="burden") {
            pvalue.left<-rbind(pvalue.left,SKAT::SKATBinary(data[,c(lb.new:result[,"upper"])],obj,method="Burden")$p.value)
          }
        }
      }
      lb.final<-lb.all[which(pvalue.left==min(pvalue.left))][1]
      rm(pvalue.left,lb.new)
      pvalue.right<-NULL
      ub.all<-NULL
      for (j in (-inward):(outward)) {
        ub.new<-result[,"upper"]+j
        if (ub.new<=up_idx) {
          ub.all<-rbind(ub.all,ub.new)
          if (test=="SKAT") {
            pvalue.right<-rbind(pvalue.right,SKAT::SKATBinary(data[,c(lb.final:ub.new)],obj)$p.value)
          } else if (test=="SKATO") {
            pvalue.right<-rbind(pvalue.right,SKAT::SKATBinary(data[,c(lb.final:ub.new)],obj,method="SKATO")$p.value)
          } else if (test=="burden") {
            pvalue.right<-rbind(pvalue.right,SKAT::SKATBinary(data[,c(lb.final:ub.new)],obj,method="Burden")$p.value)        }
        }
      }
      ub.final<-ub.all[which(pvalue.right==min(pvalue.right))][1]
      k<-length(c(lb.all,ub.all))-2
      if (fast.path) {
        pvalue.right.corrected<-pvalue.right*(bin/2+log2(bin)-1+k)
        steps <- (bin/2+log2(bin)-1+k)
      } else {
        pvalue.right.corrected<-pvalue.right*(bin-1+k)
        steps <- (bin-1+k)
      }
      pvalue.right.corrected<-ifelse(pvalue.right.corrected>1,1,pvalue.right.corrected)
      result.final[i,] <-cbind(lb.final,ub.final,ub.final-lb.final+1,min(pvalue.right.corrected)[1],steps)
    } else {
      if (fast.path) {
        result[,"p.value"]<-result[,"p.value"]*(bin/2+log2(bin)-1)
        result[,"p.value"]<-ifelse(result[,"p.value"]>1,1,result[,"p.value"])
        steps <- (bin/2+log2(bin)-1)
      } else {
        result[,"p.value"]<-result[,"p.value"]/(bin/(result[,"upper"]-result[,"lower"]+1))*(bin-1)
        result[,"p.value"]<-ifelse(result[,"p.value"]>1,1,result[,"p.value"])
        steps <- (bin/(result[,"upper"]-result[,"lower"]+1))*(bin-1)
      }
      result.final[i,]<-t(c(result[,"lower"],result[,"upper"],result[,"upper"]-result[,"lower"]+1,result[,"p.value"],steps))
    }
  }
}

ZFA.SKAT <- function(boundResult,data, y, obj,test,bin,fast.path,filter.pval,adjacent,thd_num){
  cls = makeCluster(thd_num)
  on.exit(stopCluster(cls))
  mgrinit(cls)
  mgrmakevar(cls,"data_share",dim(data)[1],dim(data)[2])
  mgrmakevar(cls,"y_share",dim(data)[1],1)
  mgrmakevar(cls,"boundResult_share",dim(boundResult)[1],dim(boundResult)[2])
  mgrmakevar(cls, "result.final",dim(boundResult)[1],5)
  data_share[,] <- data
  y_share[,] <- y
  boundResult_share[,] <- boundResult
  clusterExport(cls,"ZFA.SKAT.mmulthread",envir=environment())
  clusterExport(cls,list("obj","test","fast.path","filter.pval","bin","adjacent"),envir = environment())
  clusterEvalQ(cls,ZFA.SKAT.mmulthread(data_share,y_share,boundResult_share,test,obj,bin,fast.path,filter.pval,adjacent,result.final))
  return(S4Vectors::as.matrix(result.final))
}